;Copyright (c) 2003-2004  Bjanko Ekinovic
;e-mail: bjankoe@mailme.dk
;Web Site: http://earth.prohosting.com/bjankoe/

; v1.12.5
; Fixed
; - lowered volume for aa guns (so other sounds can be heard too :)
; - base control meter draws soldier images (instead of rect)
; - reload delay added after last shot (so click-reload-click-etc won't work)
; - soldiers fall free for a few seconds before opening parachutes
; - pause/exit game (no waitkey on menu start)
; - when base is occupied (100%), number doesn't reset during game over message
; - when base is occupied (100%), all guns are destroyed
; - default volume set to 1/4 (.25) at first run


.top
Global zetitle$ = "AA Defense"
AppTitle zetitle$

InstallCloseHandler(55, zetitle$)


SeedRnd MilliSecs()

Global totalmem;video memory available
Global avail;available memory
Const currentver = 1125
Global screendepth = 16;color depth

If GfxModeExists(640,480,32) 
	screendepth = 32
Else
	screendepth = 16
End If

Const gfxcenter = 320
Const gfycenter = 240

Graphics 640,480,screendepth,2

SetBuffer BackBuffer()

totalmem = TotalVidMem();video memory available
avail = AvailVidMem()

Global mastervolume# = 0.25
Global cdir$ = CurrentDir$()
check_firstgame()

Dim sine#(540)
For n=0 To 540
	sine#(n) = Sin#(n-90)
Next

Global windowed = 1

.images_globals
Global font_ui
Global font_big
Global font_huge
Global img_ui
Global img_pause
Global img_menu
Global img_gameover
Global img_scores
Global img_newhigh
Global img_inputwin
Global img_help
Global namelength
Global img_lm
Global img_rm
Global img_ground
Global img_grass
Global ui_bulletsleft
Global img_background
Global ui_mgleft
Dim img_bunkers(1,1)

Dim img_ammo(1)
Global img_aim
Global img_firecontrol
Global img_pole
Global img_bulletexp
Global hitexp_baseimage
Global img_hitexplosion

;ui text images
Global img_score
Global img_wave
Global img_destroy
Global img_basecontrol

;type enemy aircrafts
Dim img_airplane(5,14,1)

;soldier_images
Dim img_soldiers(4)
Global img_para

;bomb images
Dim g_bomb(1)
;
Global img_smoke
Dim img_cloud(4)


.keys
;keys
Const key_newgame = 57
Const key_windowed = 66
Const key_pause_game = 1
Const key_pause_game2 = 25
Const key_restartgame = 19
Const key_showscores = 59;F1
Const key_showinfo = 60;F2
Const key_firegun = 56
Const key_firemg = 57
;end keys

.game_globals
Global windspeed# = .2;.1
Global gravity# = .2
Global g_id = 1
Global allow_fire = 0
Global xmouse
Global ymouse
Global movmousex
Global movmousey
Global movecount

Const maxnrplanes = 2
Global aircraft_time; = MilliSecs()
Global aircraft_timer
Global bullet_time = MilliSecs()
Global gunrefiretime
Global firecontrol_dmg = 0
Global air_delay = 5000

.level_globals
Global g_gameon = 0
Global g_destroy = 0
Global g_bestscore
Global g_score = 0
Global level_destroy = 20
Global g_speed = 2
Global g_firechance
Global g_wave = 0
Global g_bombchance = 0
Global g_parachance = 1
Global g_buildingsleft = -1
Global gameovertime = 0
Global gameovertimer = MilliSecs()
Global showscores = 1; if > 0 shows hiscore
Global newscore = 0;if > 0 it asks to type a name for highscore
Global show_info = 0;if 1 shows game info screen, else menu
Dim highnames$(10)
Dim scores(10)
Dim bulletsfired(1,1)

; AA GUN AND MG GLOBALS
.aa_globals
Global g_bulletsleft = 10
Global g_mgbulletsleft = 100
Global mgbullet_time = MilliSecs()
Global mgreloadwait = MilliSecs()
Global mgbulletdelay = 100;starting refire delay for aa mg (+100 for each destroyed)
Global bulletdelay = 250;starting refire delay for aa cannon (+250 for each destroyed)
Global allow_mg = 0
Global gunreloadtime = MilliSecs()

;sounds
.sounds
Dim sounds(8)
Global volumeshowtime = MilliSecs()
Global volumeshowtimer = MilliSecs()
Global nrsounds = 0
Const maxsounds = 13
Dim gunchn(1);dedicated channels for AA gun and mg sounds
Global sounds_on = 0;if sound card missing, sound creation will be disabled


Type players
	Field ptype;0 gun, 1 mg
	Field pid
	Field elevation
	Field velocity#
	Field plx, ply
	Field gunlength
	Field pfire
	Field fx, fy
End Type

Type bullets
	Field bx#, by#
	Field bxold
	Field byold
	Field bspeed#
	Field bangle#
	Field bspeedx#, bspeedy#
	Field btimeout
	Field btype
	Field bresistance#
	Field c.channel
End Type

Type aircrafts
	Field ax#, ay#
	Field aspeedx#, aspeedy#
	Field aangley, aimangley
	Field bombsleft
	Field afirechance
	Field aimage
	Field aprop
	Field atype
	Field adamage
	Field admgarea[1]
	Field aside
	Field abombtimer
	Field bombzone
	Field c.channel
End Type
Const aleftynormal = 180
Global spdx#, spdy#

Type soldiers
	Field soldierx
	Field soldiery
	Field spara
	Field sparatime
	Field sanim
End Type

Type bombs
	Field bombx#, bomby#
	Field bospeedx#, bospeedy#
	Field bombimage
	Field c.channel
End Type

Type bunkers
	Field bunkerfront
	Field bunkerback
	Field buildid
	Field buildingx, buildingy
	Field builddamage	
End Type

Type explosions
	Field exptype
	Field ex#
	Field ey#
	Field eswitchframe
	Field expspeedx#
	Field expspeedy#
End Type

Type debris
	Field dx#
	Field dy#
	Field d_speedx#
	Field d_speedy#
	Field d_timeout
	Field d_size#
	Field d_type
End Type

Type smoke
	Field smtimeout
	Field smx#, smy#
	Field smspeed#
	Field smcolor
End Type

Type clouds
	Field cx#, cy
	Field cspeed#
	Field cloudtype
End Type

Type channel
	Field chn
	Field pan#
	Field volume#
	Field pitch
End Type

Const fps =30
maintimer = CreateTimer(fps)

load_config()
loadscores()
load_images()
load_sounds()

load_menu_image(0);main menu
load_menu_image(3);hiscores
;load_menu_image(5);game info

Global menutimer
Global debrisnr;counds nr of debris particles
Global smokey;used by debris type to generate smoke

Global gametimer = MilliSecs()

HidePointer()

Global game_min = 0
Global game_sec = 0
Global game_tick = MilliSecs()
Global goair = 1

Global time_delta
Global time_delta_sec#
Global time_new
Global time_old

.loop_start_______
;LOOP XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
Repeat 

WaitTimer(maintimer)

game_ticker = MilliSecs()
If game_tick < game_ticker
	game_sec = game_sec + 1
	If game_sec > 59
		game_min = game_min + 1
		game_sec =0
	End If
	game_tick = game_ticker+1000
End If

.set_volume
If KeyDown(201)
	mastervolume# = mastervolume# + .025
	If mastervolume# > 1 mastervolume# = 1
	volumeshowtime = MilliSecs()+2500
End If

If KeyDown(209)
	mastervolume# = mastervolume# - .025
	If mastervolume# < 0 mastervolume# = 0
	volumeshowtime = MilliSecs()+2500
End If



.game_over
If g_buildingsleft = 0
	If gameovertime = 0
		gameovertimer = MilliSecs()
		load_menu_image(2)
		newscore = updatescores()
		If newscore > 0
			showscores = 1
			highnames$(newscore) = ""
		End If
	End If
	g_gameon = 2
	g_bombchance = 0
	g_parachance = 1
	savescores()
	gameovertime = MilliSecs()-gameovertimer
	If gameovertime > 5000
		g_gameon = 0
		free_images()
		free_all_objects()
		load_images()
		load_sounds()
		savescores()
		save_config()
		g_bombchance = 0
		gameovertime = 0
		FreeImage img_gameover
		g_buildingsleft = -1
		g_wave = 1
		air_delay = 5000
		If newscore > 0
			load_menu_image(4);new high
		End If
		load_menu_image(3)
		load_menu_image(0)
;		load_menu_image(5)
		menutime = menutimer
	End If
End If
.pause_game
If KeyHit (key_pause_game) Or KeyHit(key_pause_game2)
	ShowPointer()
	If g_gameon = 1
		load_menu_image(1)
		For ch.channel = Each channel
			PauseChannel ch\chn
		Next
		SetBuffer FrontBuffer()
		DrawImage img_pause,320,240
		SetBuffer BackBuffer()
		FlushKeys()
		FlushMouse()
		While pause = 0 And pausem = 0
			WaitTimer(maintimer)
			pause = GetKey()
			pausem = GetMouse()
			If KeyHit(key_pause_game) Or KeyHit(key_pause_game2)
				free_images()
				free_all_objects()
				savescores()
				save_config()
				FreeTimer(maintimer)
				used = (TotalVidMem()-AvailVidMem()); Shr 10

				UnInstallCloseHandler()
				End
			End If
		Wend
		For ch.channel = Each channel
			ResumeChannel ch\chn
		Next
		HidePointer()
		pause = 0
		pausem = 0
		FreeImage img_pause
		FlushKeys()
		FlushMouse()
	Else
		free_images()
		free_all_objects()
		savescores()
		save_config()
		FreeTimer(maintimer)
		used = (TotalVidMem()-AvailVidMem()); Shr 10
		FlushKeys()
		UnInstallCloseHandler()
		End
	End If
End If

.fps_key
If KeyHit(88)
	fpsshow = Not fpsshow
End If

xmouse= MouseX()
ymouse= MouseY()

If xmouse < 5 Then MoveMouse 5,ymouse
If xmouse > 635 Then MoveMouse 635,ymouse
If ymouse > 430 Then MoveMouse xmouse,430

.create_aircrafts
aircraft_time = MilliSecs()
If aircraft_time > aircraft_timer + air_delay

	cloudchance = Rnd(0,1)
	If cloudchance = 0
		create_clouds()
	End If

	side = Rnd(0,1)
	If side = 0 
		side = -1
	End If
	airtype = Rnd(0,2)
	createaircraft(airtype, side)
	aircraft_timer = aircraft_time
	extraschance = Rnd(0,100)
End If

.switch_levels
If g_destroy < 1
	g_wave = g_wave + 1
	level_destroy = 5 + (g_wave/10)*5; + 5
	air_delay = air_delay - 50
	If air_delay < 1000 air_delay = 1000
	g_destroy = level_destroy
	If g_wave > 10
		g_speed = 2
	End If
	redraw_waveimage()
	redraw_destroyimage()
End If

.exit_game
If KeyHit(55)
	free_images()
	free_all_objects()
	savescores()
	save_config()
	FreeTimer(maintimer)
	FlushKeys()
	UnInstallCloseHandler()
	End
End If


Cls

.draw_stuff
DrawBlock img_background,0,40;20
For g=0 To 10
	DrawImage img_grass,g*64,380
Next
DrawImage img_firecontrol,335,430
DrawImage img_pole,330,395

.update_game
	
	update_soldiers()
	updatebullet()
	updatebombs()
	updateaircraft()
	update_clouds()
	updatesmoke()
	update_debris()
	updateexplosions()
	updateplayers()


.draw_stuff2
	draw_bullets()
	draw_soldiers()
	DrawImage img_ground,0,440	
	draw_player()
	draw_bullets()
	draw_bombs()
	draw_aircrafts()
	draw_smoke()
	draw_debris()
	updatebunkers()
	draw_explosions()
	draw_clouds()
	If sounds_on = 1 Then update_soundchannel()
	
DrawBlock img_ui,0,0
For nb=1 To g_bulletsleft
	DrawImage ui_bulletsleft,nb*8+64,18
Next
mghalf = g_mgbulletsleft Shr 1
For nb=1 To mghalf
	DrawImage ui_mgleft,nb Shl 2 +225,17
Next
For nb = 1 To (g_mgbulletsleft-mghalf)
	DrawImage ui_mgleft,nb Shl 2+225,27
Next

.mouse_hit_extra
;If MouseHit(3)
;	create_soldier(xmouse,ymouse)
;	createbombs(xmouse, ymouse,0)
;End If

.hiscores
If g_gameon = 0
	g_speed = 2
	menutimer = MilliSecs()
	If menutimer > menutime Or KeyHit(key_showscores); 2and newscore = 0
		If newscore = 0; And show_info = 0
			showscores = Not showscores
			menutime = menutimer + 10000
		End If
	End If
	
	If showscores = 1
		DrawImage img_scores,320,240
		If newscore > 0
			DrawImage img_newhigh,320,100
			DrawImage img_inputwin,245,170+newscore*15
			key = GetKey()
			namelength = Len(highnames$(newscore))
			If key <> 0 And key <> 13
				If namelength < 1 Then namelength = 1
				If namelength > 10 Then namelength = 10
				If key = 8
					highnames$(newscore) = Left$(highnames$(newscore),namelength-1)
				Else
					highnames$(newscore) = highnames$(newscore) + Chr$(key)
				End If
			End If
			Color 255,255,255
			Text 250,170+newscore*15,Left$(highnames$(newscore),10)
			
			If key = 13
				highnames$(newscore) = Left$(highnames$(newscore),10)
				newscore = 0
				savescores()
				FreeImage img_newhigh
				FreeImage img_scores
				load_menu_image(3)
				showscores = 1
				g_bombchance = 0
				g_parachance = 1
				menutime = menutimer + 10000
				FlushKeys()
				FlushMouse()
			End If
		End If
	FlushKeys()
	Else
		DrawImage img_menu,320,240
	End If
	
	.switch_screens
	If KeyHit(key_windowed)
		If g_gameon = 0
			windowed = Not windowed
			free_images()
			free_all_objects()
			Graphics 640,480,screendepth,(windowed+1)
			load_images()
			load_sounds()
			load_menu_image(3)
			load_menu_image(0)
	;		load_menu_image(5)
			MoveMouse 320,240
		End If
	End If
	
	.newgame
	If KeyHit(key_newgame) Or MouseHit(1) Or MouseHit(2)
		If g_gameon = 0 And newscore = 0
			FreeImage img_menu
			FreeImage img_scores
			FreeImage img_help
			start_new_game()
		End If
	End If
End If

If g_gameon = 2
	DrawImage img_gameover,320,240
	FlushKeys()
	FlushMouse()
End If


.show_soundvolume_graphics
volumeshowtimer = MilliSecs()
If volumeshowtime > volumeshowtimer
	Color 190,240,180

	Text 100,450,"VOLUME: ",1,1
	cvolume = mastervolume#*20	
	For n=0 To cvolume
		Rect (n*20)+150,440,10,20,1
	Next
	For n=cvolume+1 To 20
		Rect (n*20)+150,440,10,20,0
	Next
		
End If

DrawImage img_score,230,0
DrawImage img_wave,350,0
DrawImage img_destroy,510,0
DrawImage img_basecontrol,536,16
.draw_cursor
DrawImage img_aim,xmouse,ymouse

;Framecounter--------------------------------------------
Framecounter_counter=Framecounter_counter+1
If Framecounter_time+1001 < MilliSecs()
	Framecounter_framerate=Framecounter_counter
	Framecounter_counter=0
	Framecounter_time=MilliSecs()
End If
Locate 0,0
Color 255,255,255
If fpsshow
	Text 0,60,"FPS: "+Framecounter_framerate
	used = (TotalVidMem()-AvailVidMem()); Shr 10
	Text 0,70,"USEDMEM: "+used
	Text 0,90,"TIME: "+game_min+" : "+game_sec
	Text 0,110,"NR OF SOUNDS: "+nrsounds
End If
;--------------------------------------------------------

.text_on_screen

Color 255,255,255

VWait : Flip False

Forever
.loop_end________


Function save_config()

cdir$ = CurrentDir$()
filein = WriteFile(cdir$+"config.dat")
	WriteInt(filein,mastervolume#*100)
CloseFile filein

End Function

Function load_config()

cdir$ = CurrentDir$()
filein = ReadFile(cdir$+"config.dat")
If filein = 0
	check_firstgame()
Else
	mastervolume# = ReadInt(filein)*.01
End If

CloseFile filein

End Function

Function free_images()

FreeFont font_ui
FreeFont font_big
FreeFont font_huge

FreeImage img_ui
FreeImage img_ground
FreeImage img_grass
FreeImage ui_bulletsleft
FreeImage ui_mgleft
FreeImage img_background
For i = 0 To 1
	For j = 0 To 1
		FreeImage img_bunkers(i,j)
	Next
Next
FreeImage img_bulletexp
FreeImage hitexp_baseimage
FreeImage img_hitexplosion
For i = 0 To 5
	For j = 0 To 14
		For k = 0 To 1
			FreeImage img_airplane(i,j,k)
		Next
	Next
Next

For i = 0 To 1
	FreeImage g_bomb(i)
Next

FreeImage img_smoke
FreeImage img_aim
FreeImage img_soldiers(0)
FreeImage img_soldiers(1)
FreeImage img_soldiers(2)
FreeImage img_soldiers(3)
FreeImage img_soldiers(4)

FreeImage img_para
FreeImage img_firecontrol
FreeImage img_pole
FreeImage img_pause
FreeImage img_menu
FreeImage img_gameover
FreeImage img_scores
FreeImage img_newhigh
FreeImage img_inputwin
FreeImage img_help
FreeImage img_lm
FreeImage img_rm
FreeImage img_ammo(0)
FreeImage img_ammo(1)
For n=0 To 4
	FreeImage img_cloud(n)
Next

FreeImage img_score
FreeImage img_wave
FreeImage img_destroy
FreeImage img_basecontrol

For ch.channel = Each channel
	StopChannel ch\chn
	nrsounds = nrsounds - 1
	Delete ch
Next

;free sounds too
For n = 0 To 8
	FreeSound sounds(n)
Next
nrsounds = 0

End Function

Function updatescores()
For i = 1 To 10
	If g_score > scores(i)
		For j=9 To i Step -1
			scores(j+1) = scores(j)
			highnames$(j+1) = highnames(j)
		Next
		scores(i) = g_score
		If i = 1 g_bestscore = g_score
		Return i
	End If
Next

Return 0

End Function


Function savescores()

filein = WriteFile(cdir$+"highscores.dat")
SeekFile(filein,0) 
For i = 1 To 10
	WriteInt(filein,scores(i))
	WriteString(filein,highnames$(i))
Next
CloseFile filein

save_config()

End Function

Function loadscores()

cdir$ = CurrentDir$()
filein = ReadFile(cdir$+"highscores.dat")
If filein = 0
	filein = WriteFile(cdir$+"highscores.dat")
	WriteInt(filein,0)
Else
	For i = 1 To 10
		scores(i) = ReadInt(filein)
		highnames$(i) = ReadString(filein)
	Next
End If
g_bestscore = scores(1)
CloseFile filein

End Function


Function createplayers()

nextpos = 1
For nrp=1 To 6
	nextpos = Not nextpos
	p.players = New players
		If nextpos = 0
;			Insert p Before First players
			p\gunlength = 20
			p\ply = 445
			p\pfire = 1
		Else
;			Insert p After First players
			p\gunlength = 15
			p\ply = 442
			p\pfire = 0
		End If
		p\ptype = nextpos
		p\pid = g_id
		g_id = g_id + 1
		p\plx = (nrp*100)-30
		p\elevation = 0
		p\velocity# = 0
		mgreloadwait = MilliSecs()
		allow_mg = 0
		createbunkers(p\pid, nextpos, p\plx)

Next

End Function


Function updateplayers()

For p.players = Each players

	elevx# = xmouse-p\plx
	elevy# = p\ply-(ymouse-40)
	p\elevation = ATan2(-elevx#,elevy#)
	p\velocity# = (elevy#*sine(p\elevation+180)-elevx#*sine(p\elevation+90))*.05
	p\fx = p\plx-p\gunlength*sine#(p\elevation+90)
	p\fy = p\ply-p\gunlength*sine#(p\elevation+180)

	bullet_time = MilliSecs()
	;fire aa guns
	If MouseDown(1) Or KeyDown(key_firegun)
		If bullet_time > gunrefiretime
			allow_fire = 1
			gunrefiretime = bullet_time + bulletdelay
			gunreloadtime = bullet_time + 500
		End If
	Else If bullet_time > gunreloadtime
		If g_bulletsleft < 10 g_bulletsleft = g_bulletsleft + 1
		gunreloadtime = bullet_time + 500
	End If
	;trigger aa mg fire
	If MouseDown(2) Or KeyDown(key_firemg)
		If bullet_time > mgreloadwait
			allow_mg = 1
			mgbullet_time = bullet_time
			mgreloadwait = bullet_time + mgbulletdelay
			mgbullet_time = bullet_time + 500
		End If
	Else If bullet_time > mgbullet_time
		If g_mgbulletsleft < 100 Then g_mgbulletsleft = g_mgbulletsleft + 1
		mgbullet_time = bullet_time + 100
	End If

	If p\ptype = 1
		If g_mgbulletsleft > 0 And allow_mg = 1
			g_mgbulletsleft = g_mgbulletsleft - 1
			;sound mg
			If ChannelPlaying(gunchn(0)) = 1
				StopChannel gunchn(0)
			End If
			gunchn(0) = PlaySound(sounds(1))
			ChannelPan gunchn(0),(p\fx/320.0)-1
			ChannelVolume gunchn(0),mastervolume#*.2
					
			Color 255,200,0
			Rect p\fx-2,p\fy-2,4,4,1
	
			createbullet(p\fx, p\fy, p\elevation#, p\velocity#, 1)
			bulletsfired(0,0) = bulletsfired(0,0) + 1
			p\pfire = Not p\pfire
			allow_mg = 0
			Insert p After Last players
		Else
			allow_mg = 0
		End If
	End If
	
	If p\ptype = 0 
		If allow_fire = 1 And g_bulletsleft > 0
			;fire gun sound
			If ChannelPlaying(gunchn(1)) = 1
				StopChannel gunchn(1)
			End If
			gunchn(1) = PlaySound(sounds(0))
			ChannelPan gunchn(1),(p\fx/320.0)-1
			ChannelVolume gunchn(1),mastervolume#*.2
				
			Color 255,200,0
			Rect p\fx-2,p\fy-2,4,4,1
			createbullet(p\fx, p\fy, p\elevation#, p\velocity#, 0)
			bulletsfired(1,0) = bulletsfired(1,0) + 1

			allow_fire = 0
			g_bulletsleft = g_bulletsleft - 1
			p\pfire = Not p\pfire
			Insert p After Last players
		Else
			allow_fire = 0
		End If
	End If
Next

End Function

Function draw_player()
For p.players = Each players
	Color 150,150,150
	Line p\plx,p\ply,p\fx,p\fy
	DrawImage img_ammo(p\pfire),p\plx-4,p\ply+3
Next
End Function

Function createbullet(b_x#, b_y#, b_angle#, b_speed#, b_btype)

b.bullets = New bullets

	b\bx# = b_x#
	b\by# = b_y#
	b\bxold = b\bx#
	b\byold = b\by#
	b\bangle# = b_angle#
	b\btype = b_btype
	Select b\btype
		Case 0;gun
			b\btimeout = 31
			b\bspeed# = b_speed#*.8
			b\bresistance# = .8
		Case 1;mg
			b\btimeout = 25
			b\bspeed# = b_speed#*1.1
			b\bresistance# = 1
		Case 2;srapnel
			b\btimeout = 8
			b\bspeed# = b_speed#
			b\bresistance# = .5
	End Select
	
	b\bspeedx# = b\bspeed#*Sine#(b\bangle#+90)
	b\bspeedy# = b\bspeed#*Sine#(b\bangle#+180)

End Function



Function updatebullet()

Local resistance# = .1

For b.bullets = Each bullets

b\bxold = b\bx#
b\byold = b\by#

b\btimeout = b\btimeout - 1

If b\btype = 0
	If b\btimeout > 25
		createsmoke(b\bx#, b\by#,  0,1)
	End If
Else
	If b\btimeout > 20
		createsmoke(b\bx#, b\by#,  0,1)
	End If
End If
If b\btype = 2
	;Function createsmoke(sm_x, sm_y, sm_smspeed ,smoketype)
	smokeit = Not smokeit
	If smokeit
		createsmoke(b\bx#, b\by#, 0, 1)
	End If
End If
If b\btype = 0 And b\btimeout = 0 ;If b\btype = 0 And
	DrawImage img_bulletexp,b\bx#-8,b\by#-8
	create_soundchannel(3,b\bx,b\by)

	For nb = 0 To 23
		;Function createbullet(b_x#, b_y#, b_angle#, b_speed#, b_btype)
		createbullet(b\bx#, b\by#, Rnd#(0,360), Rnd(2,8), 2)
	Next
Else
	If b\btype = 0;GUN
		b\bspeedx# = b\bspeedx#
		b\bspeedy# = b\bspeedy# - resistance# - gravity#*.1
		b\bx# = b\bx#-(b\bspeedx#*b\bresistance#)
		b\by# = b\by#-(b\bspeedy#*b\bresistance#)
		b\bxold = b\bxold-((b\bx#-b\bxold)*.005)
		b\byold = b\byold-((b\by#-b\byold)*.005)
		
	Else;if b\btype = MG
		b\bspeedx# = b\bspeedx#
		b\bspeedy# = b\bspeedy# - gravity# - resistance#
		b\bx# = b\bx#-(b\bspeedx#*b\bresistance#)
		b\by# = b\by#-(b\bspeedy#*b\bresistance#)
		b\bxold = b\bxold-((b\bx#-b\bxold)*.005)
		b\byold = b\byold-((b\by#-b\byold)*.005)
		
		For a.aircrafts = Each aircrafts
			If RectsOverlap(a\ax-a\admgarea[0],a\ay-a\admgarea[1],a\admgarea[0]*2,a\admgarea[1]*2,b\bx-5,b\by-5,5,5)
				Color 255,0,0
				Rect b\bx-1,b\by-1,2,2,1
				If b\btype = 1 And b\btimeout < 10
					a\adamage = a\adamage - 2
					bulletsfired(0,1) = bulletsfired(0,1) + 1
					create_debris(b\bx#, b\by#, -a\aspeedx#, 3, 0);<<<
					
					b\btimeout = -1
					create_debris(b\bx#, b\by#, -a\aspeedx#, 3, 0)

				Else If b\btype = 2
					a\adamage = a\adamage - 2
					bulletsfired(1,1) = bulletsfired(1,1) + 1
					b\btimeout = -1
					create_debris(b\bx#, b\by#, -a\aspeedx#, 0, 0)
				End If
			End If
		Next
		If b\btimeout < 0 ;If b\btype = 0 And
			b\bspeedx# = b\bspeedx# * .9
			b\bspeedy# = b\bspeedy# * .9
		End If
		For bo.bombs = Each bombs
			If RectsOverlap(bo\bombx-2,bo\bomby-2,4,4,b\bx-5,b\by-5,5,5)
				bo\bomby = 500
			End If
		Next
	End If
End If

If b\by < 400
For s.soldiers = Each soldiers
	If s\spara = 0
		If RectsOverlap(b\bx-2,b\by-2,4,4,s\soldierx,s\soldiery-6,16,8)
			s\spara = 2
;			bulletsfired(1,1) = bulletsfired(1,1) + 1
		End If
	End If
	If RectsOverlap(b\bx-2,b\by-2,4,4,s\soldierx+4,s\soldiery+4,6,10)
		g_score = g_score + 20
		redraw_scoreimage()
		redraw_destroyimage()
	 	Delete s
		b\btimeout = -50
	End If
Next
End If

If b\btimeout < 0 Or b\by# > 450 Delete b
Next

End Function

Function draw_bullets()

For b.bullets = Each bullets
	Select b\btype
		Case 0
			Color 255-( g_bulletsleft*25.5)*Float((g_bulletsleft*25.5)/255.0),( g_bulletsleft*25.5),0
		Case 1
			Color 255-((( g_mgbulletsleft Shr 4)Shl 4)*2.55)*Float((g_mgbulletsleft*2.55)/255.0),50+((( g_mgbulletsleft Shr 4)Shl 5)),0
	End Select
	
	Line b\bxold,b\byold,b\bx#,b\by#
Next

End Function

Function createaircraft(a_type, a_side)

a.aircrafts = New aircrafts
	a\atype = a_type
	a\aside = a_side
	a\ay = Rnd(55,350)
	a\aspeedx# = (a\atype+g_speed+Rnd(0,1))*a\aside
	g_firechance = Rnd(0,(g_bombchance+(g_wave Shr 1)))
	a\afirechance = g_firechance*(3-a\atype)
	
	Select a\atype
		Case 0;bomber(32x64)
			a\adamage = 26;+20 test
			a\admgarea[0] = 32
			a\admgarea[1] = 10
			a\bombsleft = Rnd(2,4)
			a\abombtimer = 15
		Case 1;fighter bomber(32x32)
			a\adamage = 13;8
			a\admgarea[0] = 16
			a\admgarea[1] = 8
			a\bombsleft = Rnd(1,2)
			a\abombtimer = 10
		Case 2;fighter(32x32)
			a\adamage = 11;6
			a\admgarea[0] = 16
			a\admgarea[1] = 8
			a\bombsleft = Rnd(0,1)
			a\abombtimer = 15
	End Select
	
	If a\aside = -1
		a\aimage = a\atype + 3
		a\ax = -100
		a\aangley = 0;a\ay
	Else
		a\aimage = a\atype
		a\ax= 740
		a\aangley = 0;a\ay
	End If
	a\bombzone = 140+Rnd(0,3)*80
	spdx# = sine#(a\aangley+180)*a\aspeedx#
	spdy# = sine#(a\aangley+90)*a\aspeedx#
If sounds_on = 1
	If nrsounds < maxsounds 
		a\c.channel = create_soundchannel(4,a\ax,a\ay)
		PauseChannel a\c\chn
		a\c\pitch = 14000+4000*a\atype-2000*((430-(a\ax#+110))/430.0)*a\aside+500*(Abs(spdx#)+spdy#);spdy#*1000
		ResumeChannel a\c\chn
	End If	
End If
	
End Function

Function updateaircraft()


For a.aircrafts = Each aircrafts

spdx# = sine#(a\aangley+180)*a\aspeedx#
spdy# = sine#(a\aangley+90)*a\aspeedx#
a\ax# = a\ax# - spdx#-((spdy#*.5)*a\aside)
a\ay# = a\ay# + spdy#

a\aprop = Not a\aprop

If a\aangley > a\aimangley Then a\aangley = a\aangley - 1
If a\aangley < a\aimangley Then a\aangley = a\aangley + 1

If a\c.channel <> Null
	a\c\volume# = ((430-Abs(430-(Int(a\ax#)+110)))/430.0)*(a\ay#/480.0)
	a\c\pan# = ((a\ax#+110)/430.0)-1
	a\c\pitch = 14000+4000*a\atype-2000*((430-(a\ax#+110))/430.0)*a\aside+500*(Abs(spdx#)+spdy#)
	ChannelPitch a\c\chn,a\c\pitch
End If

	
If a\adamage > 4

	divechance = Rnd(0,500)
	dc = (3-(a\atype))*(g_wave)+5
	If divechance < dc
		If a\atype <> 0
			a\aimangley = Rnd(-35,35)
		End If
	End If
	
	If a\ay# > 390
		a\aimangley = a\aside*Rnd(-35,0)
	ElseIf a\ay# < 55
		a\aimangley = a\aside*Rnd(0,35)
	End If

	
	If a\ay# < 250
		If a\ax > 20 And a\ax < 620
			If a\atype = 0 Or a\atype = 3
			parachance = Rnd(g_parachance,100)
				If parachance < 1
					create_soldier(a\ax,a\ay)
				End If
			End If
		End If
	End If
	
	a\abombtimer = a\abombtimer - 1

	a\bombzone = a\bombzone - Abs(spdx#)
	If a\bombsleft > 0
		chance = Rnd(0,1000)
		If chance < a\afirechance
			If a\abombtimer < 0 And a\bombzone < 0
				createbombs(a\ax#-2,a\ay#-2,a\aspeedx#)
				a\bombsleft = a\bombsleft - 1
				If a\bombsleft < 0 a\bombsleft = 0
				a\abombtimer = 15
			End If
		End If
	End If
	
Else;
	If a\adamage > -10 And a\adamage < 0
		a\abombtimer = 0
		a\adamage = -10
	End If
	
	smx = a\ax+sine#(a\aangley+180)
	createsmoke(smx+Rnd(-4,4), a\ay-Rnd(-2,2), -a\aside*a\aspeedx#, 1)
	createsmoke(smx+Rnd(-4,4), a\ay-Rnd(-2,2), -a\aside*a\aspeedx#, 1)
	createsmoke(smx+Rnd(-4,4), a\ay-Rnd(-2,2), -a\aside*a\aspeedx#, 1)
	If a\atype > 0
		a\aimangley = a\aside*35;*(a\atype+1)
	Else 
		a\aimangley = a\aside*11;*(a\atype+1)
	End If
	If a\c.channel <> Null
		a\c\volume# = a\c\volume# + Rnd#(-.25,.25)
	End If
End If
If a\ay > 440
	a\adamage = -100
	a\abombtimer = 50
	spdx# = spdx#*.25
	spdy# = -spdy#
End If

If a\adamage < 5
	
	If a\adamage = -10
		expx = a\ax+Rnd(-(a\admgarea[0] Shr 1),a\admgarea[0] Shr 1)
		expy = a\ay+Rnd(-a\admgarea[1],a\admgarea[1])
		createexplosions(expx,expy,0,spdx#,spdy#)
		create_debris(a\ax,a\ay, -a\aspeedx#, 4, Rnd(1,5));create explosion debris
		a\adamage = a\adamage -1
	End If

	a\abombtimer = a\abombtimer +1
	
	If a\abombtimer > Rnd(25,150) Or a\adamage < -15
		create_soundchannel(Rnd(7,8),a\ax,a\ay)

		For n=0 To 2-Abs(a\atype)
			expx = a\ax+Rnd(-a\admgarea[0],a\admgarea[0])
			expy = a\ay+Rnd(-a\admgarea[1],a\admgarea[1])
			createexplosions(expx,expy,0,spdx#,spdy#)
			maxexp = maxexp - 1
		Next
		create_debris(a\ax,a\ay, -a\aspeedx#, 4, Rnd(1,5));create explosion debris

		g_score = g_score + 50*(a\atype+1)
		If a\c.channel <> Null
			StopChannel a\c\chn
			Delete a\c.channel
			nrsounds = nrsounds - 1
		End If
		Delete a
		g_destroy = g_destroy - 1
		redraw_scoreimage()
		redraw_destroyimage()
	End If
Else 
	If a\ax < -100 Or a\ax > 740
		If a\adamage < 5 
			g_score = g_score + 50*Abs(a\atype+1)
			g_destroy = g_destroy - 1
			redraw_scoreimage()
			redraw_destroyimage()
		End If

		If a\c.channel <> Null
			StopChannel a\c\chn
			Delete a\c.channel
			nrsounds = nrsounds - 1
		End If
		Delete a
	End If
End If

Next

End Function

Function draw_aircrafts()

For a.aircrafts = Each aircrafts
	DrawImage img_airplane(a\aimage,((a\aangley/7)+7),a\aprop),a\ax#,a\ay#
Next

End Function


Function createbombs(bomb_x#, bomb_y#,bomb_speed#)

bo.bombs = New bombs

If bomb_speed# > 0
	bo\bombimage = CopyImage(g_bomb(0))
Else
	bo\bombimage = CopyImage(g_bomb(1))
End If
bo\bombx# =  bomb_x#
bo\bomby# =  bomb_y#+10
bo\bospeedx# = bomb_speed#
bo\bospeedy# = gravity

bo\c = create_soundchannel.channel(6,bo\bombx,bo\bomby)

End Function

Function updatebombs()


For bo.bombs = Each bombs

bo\bospeedx# = bo\bospeedx# *.99
bo\bospeedy# = bo\bospeedy# + gravity#*2
If bo\bospeedy# > 2 bo\bospeedy# = 2
bo\bombx# = bo\bombx# - bo\bospeedx#
bo\bomby# = bo\bomby# + bo\bospeedy#

;adjust sound pan
If bo\c.channel <> Null
	bo\c\pan# = (bo\bombx#/320)-1
End If

If bo\bomby# > 420
	If ImagesCollide(bo\bombimage,bo\bombx,bo\bomby,0,img_ground,0,440,0)
		SetBuffer ImageBuffer(img_ground)
		Color 0,0,0
		Oval bo\bombx-8,bo\bomby-448,16,16,1
		create_soundchannel(2,bo\bombx,bo\bomby)
				
		createexplosions(bo\bombx,bo\bomby,1,0,-1)
		create_debris(bo\bombx,bo\bomby,-bo\bospeedx#, 0, 59);create ground debris
		bo\bomby# = 500
		SetBuffer BackBuffer()
	End If

	For bu.bunkers = Each bunkers
		If ImageRectCollide(bu\bunkerfront,bu\buildingx,bu\buildingy,0,bo\bombx-4,bo\bomby-4,8,8)

			SetBuffer ImageBuffer(bu\bunkerfront)
				Color 0,0,0
				Oval bo\bombx-(bu\buildingx-16),bo\bomby-(bu\buildingy-16),8,8,1
			SetBuffer BackBuffer()
			SetBuffer ImageBuffer(bu\bunkerback)
				Color 0,0,0
				Oval bo\bombx-(bu\buildingx-16),bo\bomby-(bu\buildingy-16)-2,6,6,1
			SetBuffer BackBuffer()

			create_soundchannel(5,bo\bombx,bo\bomby)

			createexplosions(bo\bombx,bo\bomby,1,0,-1)
			createexplosions(bo\bombx,bo\bomby,0,0,-2)
			create_debris(bo\bombx,bo\bomby,-bo\bospeedx#,1,49)
			create_debris(bo\bombx,bo\bomby, 0, -bo\bospeedx#, Rnd(1,9));create explosion debris

			bu\builddamage = bu\builddamage - 1
			If bu\builddamage = 0
				bu\builddamage = -10
			End If
			bo\bomby# = 500
		Else 
			If ImageRectCollide(bu\bunkerback,bu\buildingx,bu\buildingy,0,bo\bombx-4,bo\bomby-4,8,8)
				SetBuffer ImageBuffer(bu\bunkerback)
					Color 0,0,0
					Oval bo\bombx-(bu\buildingx-16),bo\bomby-(bu\buildingy-16),10,10,1
				SetBuffer BackBuffer()
				
				create_soundchannel(5,bo\bombx,bo\bomby)

				create_debris(bo\bombx,bo\bomby,-bo\bospeedx#,1,49)
				create_debris(bo\bombx,bo\bomby, 0, -bo\bospeedx#, Rnd(1,9));create explosion debris
				createexplosions(bo\bombx,bo\bomby,1,0,-1)
				createexplosions(bo\bombx,bo\bomby,0,0,-2)
				
				bu\builddamage = bu\builddamage - 1
				If bu\builddamage = 0
					bu\builddamage = -10
				End If
				bo\bomby# = 500
			End If
		End If
	Next
	
	If bo\bomby# > 480
		FreeImage bo\bombimage
		If bo\c.channel <> Null
			If ChannelPlaying(bo\c\chn) = 1
				StopChannel bo\c\chn
			End If
		End If
		Delete bo
	End If
End If

Next

End Function

Function draw_bombs()

For bo.bombs = Each bombs
	DrawImage bo\bombimage,bo\bombx#,bo\bomby#
Next

End Function

Function createbunkers(bid, bunkertype, bx)

bu.bunkers = New bunkers

	bu\bunkerfront = CopyImage(img_bunkers(bunkertype,0))
	bu\bunkerback = CopyImage(img_bunkers(bunkertype,1))
	bu\buildid = bid
	bu\buildingx = bx
	Select bunkertype
		Case 0
		bu\buildingy = 445
		bu\builddamage = 5
		Case 1
		bu\buildingy = 442
		bu\builddamage = 5
	End Select

End Function

Function updatebunkers()
For bu.bunkers = Each bunkers
	DrawImage bu\bunkerback,bu\buildingx,bu\buildingy
	DrawImage bu\bunkerfront,bu\buildingx,bu\buildingy

	If bu\builddamage > 0
		Color 250-(bu\builddamage*bu\builddamage*10),bu\builddamage*bu\builddamage*10,bu\builddamage*bu\builddamage*2
	Else
		Color 20,20,20
		If bu\builddamage = -10
			g_buildingsleft = g_buildingsleft - 1
			createexplosions(bu\buildingx,bu\buildingy,1,0,-1)
			create_debris(bu\buildingx,bu\buildingy,0,1,59)
			create_debris(bu\buildingx,bu\buildingy, 0, 4, Rnd(1,9));create explosion debris
			bu\builddamage = -20
			.bunker_Destroyed
			For p.players = Each players
				If p\pid = bu\buildid
					If p\ptype = 0
						bulletdelay = bulletdelay +200
					Else 
						If p\ptype = 1
							mgbulletdelay = mgbulletdelay + 100
						End If
					End If
					Delete p
				End If
			Next
		End If

	End If
	Rect bu\buildingx-8,bu\buildingy+20,16,4,1
	Color 50,50,50
	Rect bu\buildingx-8,bu\buildingy+20,16,4,0
Next
End Function

Function createexplosions(e_x,e_y,exp_type, exp_speedx#, exp_speedy#)

e.explosions = New explosions

e\ex# = e_x
e\ey# = e_y
e\expspeedx# = exp_speedx#
e\expspeedy# = exp_speedy#

Select exp_type
	Case 0
		e\eswitchframe = Rnd(0,8)
	Case 1
		e\eswitchframe = 0
	Case 2
		e\eswitchframe = 6
End Select

End Function

Function updateexplosions()

For e.explosions = Each explosions
	e\ex# = e\ex# - e\expspeedx#
	e\ey# = e\ey# + e\expspeedy#
	e\expspeedx# = e\expspeedx# * .99
	e\expspeedy# = e\expspeedy# * .99
	e\eswitchframe = e\eswitchframe + 1

	If (e\eswitchframe Shr 1) > 8
		Delete e
	End If
Next
End Function

Function draw_explosions()

For e.explosions = Each explosions
	DrawImage img_hitexplosion,e\ex-32,e\ey-32,e\eswitchframe Shr 1
Next

End Function


Function create_debris(exp_x, exp_y, spx#, dtype, maxd)
For dn = 0 To maxd
	debrisnr = debrisnr + 1
	d.debris = New debris
	d\dx# = exp_x
	d\dy# = exp_y
	d\d_speedx# = spx#
	d\d_speedy# = Rnd#(-6,-1)+Abs(d\d_speedx#*.1)
	d\d_size# = Rnd#(1,2)
	d\d_type = dtype

Select d\d_type
	Case 0
		d\d_timeout = Rnd#(15,80)
		d\d_speedx# = d\d_speedx#  + Rnd#(-3,3)
	Case 1
		d\d_timeout = Rnd#(15,80)
		d\d_speedx# = d\d_speedx#  + Rnd#(-3,3)
	Case 2
		d\d_timeout = Rnd#(15,80)
		d\d_speedx# = d\d_speedx#  + Rnd#(-5,5)
	Case 3
		d\d_timeout = Rnd#(5,15)
		d\d_speedx# = d\d_speedx#  + Rnd#(-5,5)
	Case 4
		d\d_timeout = Rnd#(10,100)
		d\d_speedx# = d\d_speedx#  + Rnd(-5,5)
		d\d_speedy# = Rnd(-2,2)
End Select
		
		
Next

End Function

Function update_debris()

For d.debris = Each debris
	d\dx# = d\dx# + d\d_speedx#
	d\dy# = d\dy# + d\d_speedy#
	d\d_speedx# = (d\d_speedx# * .99)
	d\d_speedy# = d\d_speedy# + gravity#*d\d_size
	If d\d_speedy# > 5 d\d_speedy# = 5

	If ImageRectCollide(img_ground,0,440,0,d\dx,d\dy,d\d_size,d\d_size)
		d\d_speedy# = -d\d_speedy#*.4
		d\d_speedx# = d\d_speedx# * .9
	End If
	d\d_timeout = d\d_timeout -1
	If d\d_timeout > 50 Or d\d_type > 1
		smokey = smokey + 1
		If smokey = 4
			createsmoke(d\dx#, d\dy#, 0, 1)
			smokey = 0
		End If
	End If
	If d\d_timeout < 0
		bufferchance = Rnd(0,15)
		If bufferchance < 5
			SetBuffer ImageBuffer(img_ground)
			Color 44,32,28
			Rect d\dx,d\dy-440,d\d_size,d\d_size,1
			SetBuffer BackBuffer()
		End If
		Delete d
		debrisnr = debrisnr - 1
	End If

Next
End Function

Function draw_debris()

LockBuffer BackBuffer()
For d.debris = Each debris
	Select d\d_type
		Case 0;ground 
			Color 64+d\d_timeout,32+d\d_timeout,28+d\d_timeout
			dcolor = (64+d\d_timeout) Shl 16 + (32+d\d_timeout) Shl 8 + (28+d\d_timeout)
		Case 1;bunker and plane explosion debris
			ccolor = d\d_timeout*2+50
			dcolor = ccolor Shl 16 + ccolor Shl 8 + (ccolor-50)
		Case 2; 
			dcolor = (170+d\d_timeout) Shl 16 + (100+Rnd(0,50)+d\d_timeout) Shl 8 + (100+d\d_timeout)
		Case 3;plane hit debris
			dcolor = (50+d\d_timeout*15) Shl 16 + (50+d\d_timeout*15) Shl 8 + (50+d\d_timeout*5)
		Case 4;plane explode debris
			dcolor = (150+d\d_timeout) Shl 16 + (100+Rnd(0,50)+d\d_timeout) Shl 8 + (50+d\d_timeout)

	End Select
	
	If d\dx > 0 And d\dx < 639
		If d\dy < 479 And d\dy > 0
			WritePixelFast(d\dx,d\dy,dcolor)
			WritePixelFast(d\dx+1,d\dy,dcolor)
			WritePixelFast(d\dx,d\dy+1,dcolor)
			WritePixelFast(d\dx+1,d\dy+1,dcolor)
		End If
	End If
Next
UnlockBuffer BackBuffer()

End Function

Function createsmoke(sm_x, sm_y, sm_smspeed ,smoketype)

sm.smoke = New smoke
	debrisnr = debrisnr + 1

	sm\smx# = sm_x
	sm\smy# = sm_y
	sm\smspeed# = sm_smspeed
;	sm\smtype = smoketype
	Select smoketype
		Case 0
			sm\smtimeout = Rnd(10,20);50)
			sm\smcolor = 50
		Case 1
			sm\smtimeout = Rnd(10,40);70)
			sm\smcolor = 50
		Case 2
			sm\smtimeout = Rnd(5,10);40)
			sm\smcolor = 50
	End Select

End Function

Function updatesmoke()

For sm.smoke = Each smoke
	sm\smspeed# = sm\smspeed# *.99; + Rnd(0,.1)
	sm\smy# = sm\smy# - .2
	If sm\smspeed# < 0 sm\smspeed# = 0
	sm\smx# = sm\smx# + sm\smspeed# + windspeed#
	sm\smtimeout = sm\smtimeout - 1
;	sm\smcolor = sm\smcolor - 1
	If sm\smtimeout < 0
		Delete sm
		debrisnr = debrisnr - 1
	End If
Next

End Function

Function draw_smoke()

LockBuffer BackBuffer()
For sm.smoke = Each smoke
	
	dcolor = (sm\smcolor+sm\smtimeout*3+Rnd(-10,10)) Shl 16 + (sm\smcolor+sm\smtimeout*3) Shl 8 + (sm\smcolor+sm\smtimeout*3)

	If sm\smx > 0 And sm\smx < 639
		If sm\smy < 479 And sm\smy > 0
			WritePixelFast(sm\smx,sm\smy,dcolor)
			WritePixelFast(sm\smx+1,sm\smy,dcolor)
			WritePixelFast(sm\smx,sm\smy+1,dcolor)
			WritePixelFast(sm\smx+1,sm\smy+1,dcolor)
		End If
	End If				
Next
UnlockBuffer BackBuffer()

End Function

Function create_soldier(sx,sy)

s.soldiers = New soldiers

s\soldierx = sx
s\soldiery = sy+10
s\spara = 2;soldier with parachute
s\sparatime = 0
s\sanim = 0
End Function

Function update_soldiers()

For s.soldiers = Each soldiers
	Select s\spara
		Case 0;soldier gliding down
			s\soldiery = s\soldiery + gravity#*6
			If s\soldiery > 430
				s\soldiery = 430
				s\spara = 1
			End If
		Case 1;soldier moving on ground
			If s\soldierx# < 320
				s\soldierx = s\soldierx + Rnd(0,1)
			Else
				s\soldierx = s\soldierx - Rnd(0,1)
			End If
			s\sanim = Not s\sanim
			If s\soldierx = 320 
				Delete s
				If firecontrol_dmg < 20
					firecontrol_dmg = firecontrol_dmg + 1
					redraw_basecontrolimage()
				Else
					g_buildingsleft = 0
					For p.players = Each players
						Delete p
					Next
					gameovertimer = MilliSecs()
				End If
			End If
		Case 2;soldier falling w/o parachute
			s\soldiery = s\soldiery + gravity#*12;*s\spara
			s\sparatime = s\sparatime + 1
			If s\sparatime = 10
				s\spara = 0
			End If
			If s\soldiery > 430
				s\soldiery = 430
				s\spara = 3
				s\sparatime = 0
			End If	
		Case 3;soldier dead
			s\sparatime = s\sparatime + 1
			If s\sparatime > 150
				Delete s
			End If 
	End Select
Next

End Function

Function draw_soldiers()

For s.soldiers = Each soldiers
	Select s\spara
		Case 0
			DrawImage img_soldiers(0),s\soldierx,s\soldiery
			DrawImage img_para,s\soldierx,s\soldiery-10
		Case 1
			DrawImage img_soldiers(1),s\soldierx,s\soldiery,s\sanim
		Case 2
			DrawImage img_soldiers(0),s\soldierx,s\soldiery		
		Case 3
			DrawImage img_soldiers(2),s\soldierx,s\soldiery+5
	End Select
									
Next

End Function


Function create_clouds()

c.clouds = New clouds
	c\cx# = -50
	c\cspeed# = Rnd#(0,1)
	cchance = Rnd(0,10)
	If cchance = 0
		c\cy = Rnd(50,350)
	Else
		c\cy = Rnd(150,200)
	End If
	c\cloudtype = Rnd(0,4)
End Function

Function update_clouds()

For c.clouds = Each clouds
	c\cx# = c\cx#+c\cspeed#+windspeed#
	If c\cx > 700
		Delete c
	End If
Next

End Function

Function draw_clouds()

For c.clouds = Each clouds
	DrawImage img_cloud(c\cloudtype),c\cx,c\cy
Next

End Function


Function load_images()


;load fonts
font_ui = LoadFont("arial",14,1,0,0)
font_big = LoadFont("arial",15,1,0,0)
font_huge = LoadFont("arial",20,0,1,0)


SetFont font_big

;UI
img_ui = CreateImage(640,40)
SetBuffer ImageBuffer(img_ui)
Color 50,50,50
Rect 0,0,640,40

Color 0,0,0
Rect 100,0,60,14,1
Color 200,200,180
Rect 100,0,60,14,0
;Line 0,13,40,13
Text 60,1,"BEST"

Color 255,255,255
Text 159-StringWidth(g_bestscore),0,g_bestscore

Color 200,200,180
Text 180,1,"SCORE"
Color 0,0,0
Rect 230,0,60,14,1
Color 250,250,180
Rect 230,0,60,14,0
;Line 120,13,170,13

Color 200,200,180
Text 310,1,"WAVE"
Color 0,0,0
Rect 350,0,60,14,1
Color 200,200,180
Rect 350,0,60,14,0
;Line 250,13,290,13

Text 440,1,"DESTROY"
Color 0,0,0
Rect 510,0,60,14,1
Color 200,200,180
Rect 510,0,60,14,0
;Line 380,13,450,13

Color 250,220,120
Text 445,20,"BASE CONTROL"
Color 0,0,0
Rect 535,15,82,23,1
Color 200,200,180
Rect 535,15,82,23,0

Text 15,20,"SHELLS"
Color 0,0,0
Rect 70,15,85,23,1
Color 200,200,180
Rect 70,15,85,23,0

Text 165,20,"BULLETS"
Color 0,0,0
Rect 225,15,210,23,1
Color 200,200,180
Rect 225,15,210,23,0

Line 0,39,640,39

SetBuffer BackBuffer()

img_score = CreateImage(60,14)
img_wave = CreateImage(60,14)
img_destroy = CreateImage(60,14)
img_basecontrol = CreateImage(82,23)

img_inputwin = CreateImage(80,14)
SetBuffer ImageBuffer(img_inputwin)
Color 0,0,0
Rect 0,0,80,14,1
Color 250,250,180
Rect 0,0,80,14,0
SetBuffer BackBuffer()

img_ground = CreateImage(640,40)
SetBuffer ImageBuffer(img_ground)

Color 44,32,28
Rect 0,0,640,40
Color 0,50,0
Rect 0,0,640,2

Color 0,0,0
For n=0 To 100
	Expl = Rnd(0,640)
	sizeo = Rnd(10,15)
	Color 0,50,0
	Oval expl-9,-9,sizeo+1,sizeo+1,1
	Color 0,0,0
	Oval expl-8,-8,sizeo,sizeo,1
Next
SetBuffer BackBuffer()


img_grass = LoadImage(cdir$+"images\grass02.png")
ui_bulletsleft = LoadImage(cdir$+"images\bulletsleft04.png")
totalmem = TotalVidMem() Shr 10
If totalmem > 7000
	img_background = LoadImage(cdir$+"images\back.png")
Else
	img_background = CreateImage(1,1)
End If
ui_mgleft = LoadImage(cdir$+"images\mgleft04.png")

img_aim = LoadImage(cdir$+"images\pointer.png")
MidHandle img_aim

;.image_fire_control
img_firecontrol = LoadImage(cdir$+"images\firecontrol.png")
MidHandle img_firecontrol
img_pole = LoadImage(cdir$+"images\pole.png")

img_bulletexp = LoadImage(cdir$+"images\bulletexplosion16.png")
hitexp_baseimage = LoadImage(cdir$+"images\explode1.png")
img_hitexplosion = CreateImage(64,64,9)
For fr=0 To 8
	SetBuffer ImageBuffer(img_hitexplosion,fr)
		DrawBlockRect hitexp_baseimage, 0,0, fr*64,0, 64,64
	SetBuffer BackBuffer()
Next
FreeImage hitexp_baseimage

nrp=0
For i = 0 To maxnrplanes
	For j = 0 To 14	
		;************** AIRPLANE IMAGES
		img_airplane(i,j,0) = LoadImage(cdir$+"images\planes\plane"+i+"a_"+j+".bmp")
		img_airplane(i,j,1) = LoadImage(cdir$+"images\planes\plane"+i+"b_"+j+".bmp")
		img_airplane(i+maxnrplanes+1,j,0) = LoadImage(cdir$+"images\planes\plane"+i+"a_left_"+j+".bmp")
		img_airplane(i+maxnrplanes+1,j,1) = LoadImage(cdir$+"images\planes\plane"+i+"b_left_"+j+".bmp")
	Next
Next
	
For i = 0 To (maxnrplanes Shl 1)+1
	For j = 0 To 14
		For k=0 To 1
			MidHandle img_airplane(i,j,k)
		Next
	Next
Next

;.soldier_images
img_soldiers(0) = LoadImage(cdir$+"images\soldier.png")
img_soldiers(2) = LoadImage(cdir$+"images\soldierdead.png")
img_soldiers(3) = LoadImage(cdir$+"images\soldierdead.png")

img_para = LoadImage(cdir$+"images\parachute.png")
img_soldiers(1) = CreateImage(32,32,2)
tempimg = LoadImage(cdir$+"images\soldiermove1.png")
SetBuffer ImageBuffer(img_soldiers(1),0)
DrawBlock tempimg,0,0
SetBuffer BackBuffer()
FreeImage tempimg
tempimg = LoadImage(cdir$+"images\soldiermove2.png")
SetBuffer ImageBuffer(img_soldiers(1),1)
DrawBlock tempimg,0,0
SetBuffer BackBuffer()
FreeImage tempimg

g_bomb(0) = LoadImage(cdir$+"images\bomb.png")
g_bomb(1) = LoadImage(cdir$+"images\bomb_left.png")
For i = 0 To 1
	MidHandle g_bomb(i)
Next

img_smoke = LoadImage(cdir$+"images\blacksmoke16.png")
MidHandle img_smoke

img_bunkers(0,0) = LoadImage(cdir$+"images\bunkerfront.png")
HandleImage img_bunkers(0,0),16,17
img_bunkers(0,1) = LoadImage(cdir$+"images\bunkerback.png")
MidHandle img_bunkers(0,1)
img_bunkers(1,0) = LoadImage(cdir$+"images\pillboxfront.png")
MidHandle img_bunkers(1,0)
img_bunkers(1,1) = LoadImage(cdir$+"images\pillboxback.png")
MidHandle img_bunkers(1,1)

img_ammo(0) = LoadImage(cdir$+"images\ammo1.png")
img_ammo(1) = LoadImage(cdir$+"images\ammo2.png")

img_cloud(0) = LoadImage(cdir$+"images\cloud1.png")
img_cloud(1) = LoadImage(cdir$+"images\cloud2.png")
img_cloud(2) = LoadImage(cdir$+"images\cloud3.png")
img_cloud(3) = LoadImage(cdir$+"images\cloud4.png")
img_cloud(4) = LoadImage(cdir$+"images\cloud5.png")
For n = 0 To 4
	MidHandle img_cloud(n)
Next

End Function

Function load_sounds()

;fire AA GUN
sounds(0) = LoadSound(cdir$+"sounds\aagunfire.ogg")
If sounds(0) <> 0
	sounds_on = 1
	;fire AA MG
	sounds(1) = LoadSound(cdir$+"sounds\aamgfire.ogg")
	;bomb explodes
	sounds(2) = LoadSound(cdir$+"sounds\groundexplosion.ogg")
	;gun shell explodes
	sounds(3) = LoadSound(cdir$+"sounds\shellexplode3.ogg")
	;bomber engine
	sounds(4) = LoadSound(cdir$+"sounds\planeidle5.ogg")
	LoopSound sounds(4)
	sounds(5) = LoadSound(cdir$+"sounds\explosion4.ogg")
	;bomb falling
	sounds(6) = LoadSound(cdir$+"sounds\dropbomb2.ogg")
	;plane explodes
	sounds(7) = LoadSound(cdir$+"sounds\planecrashed6.ogg")
	SoundVolume sounds(7),.2
	;plane explodes
	sounds(8) = LoadSound(cdir$+"sounds\planecrashed7.ogg")
	SoundVolume sounds(8),.2
	For n = 0 To 8
		SoundVolume sounds(n),mastervolume#
	Next
End If
	
End Function

Function free_all_objects()

For p.players = Each players
	Delete p
Next

For bu.bunkers = Each bunkers
	FreeImage bu\bunkerfront
	FreeImage bu\bunkerback
	Delete bu
Next

For a.aircrafts = Each aircrafts
	Delete a
Next

For bo.bombs = Each bombs
	FreeImage bo\bombimage
	Delete bo
Next

For s.soldiers = Each soldiers
	Delete s
Next

For b.bullets = Each bullets
	Delete b
Next

For e.explosions = Each explosions
	Delete e
Next

For ch.channel = Each channel
	StopChannel ch\chn
	Delete ch
	nrsounds = 0
Next

End Function

Function start_new_game()
	
;	load_config()
	free_images()
	free_all_objects()
	If totalmem < 8000
		windowed = 0
		Graphics 640,480,screendepth,(windowed+1)
	End If
	load_images()
	load_sounds()
	createplayers()
	g_bombchance = 2
	g_parachance = 0
	g_score = 0
	g_wave = 1
	air_delay = 2500
	g_buildingsleft = 6
	firecontrol_dmg = 0
	g_destroy = 5
	g_speed = 2
	g_bulletsleft = 10
	g_mgbulletsleft = 100
	bulletdelay = 250
	mgbulletdelay = 75
	g_gameon = 1
	gameovertime = 0
	MoveMouse 320,240
	movmousex = xmouse
	movmousey = ymouse
	game_min = 0
	game_sec = 0
	redraw_scoreimage()
	redraw_destroyimage()
	redraw_waveimage()	
	redraw_basecontrolimage()
End Function

Function load_menu_image(imagenr)

Local colvalue

Select imagenr

Case 0
	img_menu = CreateImage(300,250)
	img_lm = LoadImage(cdir$+"images\lmouse.png")
	MidHandle img_lm
	img_rm = LoadImage(cdir$+"images\rmouse.png")
	MidHandle img_rm
	
	SetBuffer ImageBuffer(img_menu)
	draw_back_transparent(img_menu,300,250,100,100,100)

	SetFont font_huge

	Color 120,120,120
	Text 151,21,"AA Defense",1,1
	Color 255,200,50

	Text 150,20,"AA Defense",1,1

	SetFont font_big

	Color 120,120,120
	Text 23,41,"SPACE or Mouse buttons"
	Text 11,66,"                        F1"
;	Text 11,75,"F2"
	Text 11,81,"                        F8"
	Text 5,96,"PAGE UP/DOWN"

;	Color 250,250,150
	Color 190,240,180

	Text 22,40,"SPACE or Mouse buttons"
	Text 10,65,"                        F1"
;	Text 10,75,"F2"
	Text 10,80,"                        F8"
	Text 4,95,"PAGE UP/DOWN"

	Color 255,255,255
	SetFont font_ui
	Text 167,41," - Start a new game"
	Text 95,66," - View Highscores"
;	Text 75,75," - View game info"
	Text 95,81," - Toggle windowed/fullscreen mode"
	Text 95,96," - Adjust Volume"

	Color 150,185,150
	Line 10,130,290,130

	SetFont font_big
	
	Color 120,120,120
	Text 151,141,"Controls",1,1
	Color 250,200,50
	Text 150,140,"Controls",1,1

	Color 190,240,180
	DrawImage img_lm,135,162
	DrawImage img_rm,135,182

	Color 120,120,120
	Text 43,156," (HOLD) ALT or "
	Text 11,176,"      (HOLD) SPACE or "
	Text 11,226,"                            ESCAPE"

	Color 190,240,180
	Text 42,155," (HOLD) ALT or "
	Text 10,175,"      (HOLD) SPACE or "
	Text 10,225,"                            ESCAPE"

	SetFont font_ui
	Color 255,255,255
	Text 140,156," - fire AA Cannons"
	Text 140,176," - fire AA Machine Guns"
	Text 140,226," - Pause game/Exit game"

	Color 200,200,180
	Rect 0,0,300,250,0
	SetBuffer BackBuffer()
	MidHandle img_menu

Case 1
	img_pause = CreateImage(200,100)
	SetBuffer ImageBuffer(img_pause)
	draw_back_transparent(img_pause,200,100,100,100,100)
	
	SetFont font_big
	Color 120,120,120
	Text 101,21,"PAUSED",1,1
	Color 190,240,180
	Text 100,20,"PAUSED",1,1

	Color 150,185,150
	Line 10,40,190,40
	Color 255,255,255
	Text 100,60,"Any key to continue",1,1
	Color 120,120,120
	Text 44,81,"ESCAPE"
	Color 190,240,180
	Text 43,80,"ESCAPE"
	SetFont font_ui
	Color 255,255,255
	Text 93,81," - Exit game"
	Color 200,200,180
	Rect 0,0,200,100,0
	SetBuffer BackBuffer()
	MidHandle img_pause

Case 2
	img_gameover = CreateImage(200,100)
	SetBuffer ImageBuffer(img_gameover)
	draw_back_transparent(img_gameover,200,100,100,100,100)

	SetFont font_big
	Color 50,50,50
	Text 101,31,"GAME OVER",1,1
	Color 255,50,20
	Text 100,30,"GAME OVER",1,1
	
	Color 150,185,150
	Line 10,50,190,50
	Color 255,255,255
	Text 100,60,"Please wait a moment",1,1
	Color 120,120,120
	Text 44,81,"ESCAPE"
	Color 190,240,180
	Text 43,80,"ESCAPE"
	SetFont font_ui
	Color 255,255,255
	Text 93,81," - Exit game"
	Color 200,200,180
	Rect 0,0,200,100,0
	
	SetBuffer BackBuffer()
	MidHandle img_gameover
Case 3
	img_scores = CreateImage(200,200)
	SetBuffer ImageBuffer(img_scores)
	draw_back_transparent(img_scores,200,200,100,100,100)

	SetFont font_big
	Color 120,120,120
	Text 101,21,"HIGHSCORES",1,1
	Color 190,240,180
	Text 100,20,"HIGHSCORES",1,1	

	Color 190,240,180
	Text 20-StringWidth(1),45,"1"
	Color 250,250,150
	Text 30,45,highnames$(1)
	Text 185-StringWidth(scores(1)),45,scores(1)	

	SetFont font_ui
	For i = 2 To 10
		Color 190,240,180
		Text 20-StringWidth(i),30+i*15,i
		Color 255,255,255
		Text 30,30+i*15,highnames$(i)
		Text 185-StringWidth(scores(i)),30+i*15,scores(i)
	Next
	
	Color 200,200,180
	Rect 0,0,200,200,0
	
	SetBuffer BackBuffer()
	MidHandle img_scores
Case 4
	img_newhigh = CreateImage(300,50)
	SetBuffer ImageBuffer(img_newhigh)
	draw_back_transparent(img_newhigh,300,50,100,100,100)

	SetFont font_big
	Color 120,120,120
	Text 151,11,"CONGRATULATIONS",1,1
	Color 190,240,180
	Text 150,10,"CONGRATULATIONS",1,1	

	Color 250,250,150
	Text 150,25,"Your score is in Top Ten!",1,0
	Text 150,35,"Please type in your name",1,0
	Color 200,200,180
	Rect 0,0,300,50,0
	
	SetBuffer BackBuffer()
	MidHandle img_newhigh
Case 5
	img_help = CreateImage(300,300)
	SetBuffer ImageBuffer(img_help)
	draw_back_transparent(img_help,300,300,100,100,100)

	SetFont font_big

	Color 120,120,120
	Text 151,11,"GAME INFO",1,1
	Color 190,240,180
	Text 150,10,"GAME INFO",1,1	
	Color 150,185,150
	
;	Line 10,20,290,20
;	Color 250,250,150

	Color 190,240,180
	Text 5,30,"GOAL:"
	SetFont font_ui

	Color 255,255,255
	Text 5,40,"  Defend your base against endless waves of "
	Text 5,50,"  enemy planes, for as long as possible."

	SetFont font_big
	Color 190,240,180
	Text 5,70,"WEAPONS:"
	SetFont font_ui

	Color 255,255,255
	Text 5,80,"- High caliber AA cannons. Shells explode"
	Text 5,90,"  causing heavy area damage, slow, low re-fire rate"
	Text 5,100,"- AA machine gun. High velocity, fast re-fire rate,"
	Text 5,110,"  but do little damage"
	
	SetFont font_big
	Color 190,240,180
	Text 5,130,"ENEMIES:"

	SetFont font_ui
	Color 255,255,255
	Text 5,140,"- Fighter (250 points). Fast, a few bombs in loadout."
	Text 5,150,"- Light Bomber (150 points). Slower than a fighter, "
	Text 5,160,"  but carries more bombs"
	Text 5,170,"- Heavy Bomber (50 points). Slow, packed with bombs."
	Text 5,180,"  Also drops paratroopers."
	Text 5,190,"- Paratroopers (20 points). If more than 20 land"
	Text 5,200,"  safely, they will take over your base resulting"
	Text 5,210,"  in game over."
	Text 5,220,"  See the BASE CONTROL status in the game."
	Text 5,230,"- Bombs. You can shoot and destroy them before"
	Text 5,240,"  they hit the ground, or more importantly"
	Text 5,250,"  your AA positions."
	Color 200,200,180
	Rect 0,0,300,300,0
	
	SetBuffer BackBuffer()
	MidHandle img_help
End Select

SetFont font_big
End Function

Function check_firstgame()

cdir$ = CurrentDir$()
filein = ReadFile(cdir$+"config.dat")

If filein = 0
	filein = WriteFile(cdir$+"config.dat")
	WriteInt(filein,mastervolume#*100)
	create_anims()
End If
CloseFile filein

End Function

Function create_anims()

Local nrplanes = 0
Local rot = 0
Local font_anim = LoadFont("arial",20,1,0,0)
SetFont font_anim
TFormFilter 0
For nrplanes = 0 To maxnrplanes
	;plane 2 anims
	image11 = LoadImage(cdir$+"images\plane"+nrplanes+"a.png")
	MidHandle image11
	image12 = LoadImage(cdir$+"images\plane"+nrplanes+"b.png")
	MidHandle image12

	rot = -40
	imgnr = 0
	Repeat
		
		SetBuffer BackBuffer()
		Color 250,200,50
		Text gfxcenter,gfycenter,"First-time run, creating animations.",1,1
		Text gfxcenter,gfycenter+15,"Please wait...",1,1
		Flip False
		rot = rot + 5
		
		tempimage = CopyImage(image11)
		RotateImage tempimage,rot
		SaveImage (tempimage,cdir$+"images\planes\plane"+nrplanes+"a_"+(14-imgnr)+".bmp")
		;flip image
		TFormImage tempimage,-1,0,0,1
		SaveImage (tempimage,cdir$+"images\planes\plane"+nrplanes+"a_left_"+imgnr+".bmp")
		FreeImage tempimage
		
		tempimage = CopyImage(image12)
		RotateImage tempimage,rot
		SaveImage (tempimage,cdir$+"images\planes\plane"+nrplanes+"b_"+(14-imgnr)+".bmp")
		TFormImage tempimage,-1,0,0,1
		SaveImage (tempimage,cdir$+"images\planes\plane"+nrplanes+"b_left_"+imgnr+".bmp")
		FreeImage tempimage

		imgnr = imgnr + 1
	Until rot = 35
	
	FreeImage image11
	FreeImage image12
	FreeImage tempimage
Next	
	FreeFont font_anim

End Function


Function draw_back_transparent(img_transp,backsizex,backsizey,colr,colg,colb)

Local colvalue = colr Shl 16 + colg Shl 8 + colb

LockBuffer ImageBuffer(img_transp)
stepx = 1
iy = 0
Repeat
	stepx = Not stepx
	ix=stepx
	Repeat
		WritePixelFast (ix,iy,colvalue)
		ix=ix+2
	Until ix>=backsizex
	iy=iy+1
Until iy>=backsizey
UnlockBuffer ImageBuffer(img_transp)
		
End Function


Function create_soundchannel.channel(sndtype,xsound,ysound)

If sounds_on = 1
	If nrsounds < maxsounds
		ch.channel = New channel
			nrsounds = nrsounds + 1
			ch\chn = PlaySound(sounds(sndtype))		
			ch\pan# = ((xsound+110)/430.0)-1
			ch\volume# = ((430-Abs(430-(xsound+110)))/430.0)*(ysound/480.0)
			ChannelVolume ch\chn,0
		Return ch.channel
	End If
End If

End Function

Function update_soundchannel()

For ch.channel = Each channel
	ChannelPan ch\chn,ch\pan#
	If ch\volume > 1 ch\volume = 1
	cvol# = ch\volume#*mastervolume#
	ChannelVolume ch\chn,cvol#
	If ChannelPlaying(ch\chn) = 0
		Delete ch
		nrsounds = nrsounds - 1
	End If
Next

End Function


Function redraw_scoreimage()

SetBuffer ImageBuffer(img_score)
	Color 0,0,0
	Rect 0,0,60,14,1
	Color 255,255,100
	Text 59-StringWidth(g_score),0,g_score
SetBuffer BackBuffer()

End Function

Function redraw_waveimage()

SetBuffer ImageBuffer(img_wave)
	Color 0,0,0
	Rect 0,0,60,14,1
	Color 255,255,255
	Text 59-StringWidth(g_wave),0,g_wave
SetBuffer BackBuffer()

End Function

Function redraw_destroyimage()

SetBuffer ImageBuffer(img_destroy)
	Color 0,0,0
	Rect 0,0,60,14,1
	Color 255,255,255
	Text 59-StringWidth(g_destroy),0,g_destroy
SetBuffer BackBuffer()

End Function

Function redraw_basecontrolimage()

Local yr=1
Local nr=0

SetBuffer ImageBuffer(img_basecontrol)
	Color 0,0,0
	Rect 0,0,82,23,1
	Color 200,0,0

	While nr<firecontrol_dmg
		yr = Not yr
		DrawImage img_soldiers(1),(Floor(nr*1.25)*3)-3*yr,yr Shl 2
		nr = nr +1
	Wend
	Color 255,255,255
	Text 41,3,firecontrol_dmg*5+"%",1,0
SetBuffer BackBuffer()

End Function